#!/bin/sh
#--------------------------------------
# Checks for known desktop environments
# Based on code from xdg-open

check_session()
{
	case "$1" in
		gnome)
			DE=GNOME;
			;;
		LXDE|lxde)
			DE=LXDE; 
			;;
		[xX]fce|[xX]fce4)
			DE=XFCE;
			;;
	esac
}

[ -z "${XDG_CURRENT_DESKTOP}" ] || exit 0

# classic fallbacks
if [ x"$KDE_FULL_SESSION" = x"true" ]; then DE=KDE;
elif [ x"$GNOME_DESKTOP_SESSION_ID" != x"" ]; then DE=GNOME;
elif [ x"$MATE_DESKTOP_SESSION_ID" != x"" ]; then DE=MATE;
elif `dbus-send --print-reply --dest=org.freedesktop.DBus /org/freedesktop/DBus org.freedesktop.DBus.GetNameOwner string:org.gnome.SessionManager > /dev/null 2>&1` ; then DE=GNOME;
fi

if [ -z "$DE" -a -n "$DESKTOP_SESSION" ]; then
	# fallback to checking $DESKTOP_SESSION
	check_session "$DESKTOP_SESSION"
fi

if [ -z "$DE" -a "$DESKTOP_SESSION" = "default" ]; then
	tmp="$(runwm --print default 2>/dev/null)"
	check_session "${tmp#*/start}"
fi

if [ -n "$DE" ]; then
	export XDG_CURRENT_DESKTOP="$DE"
fi
